#include "main.h"

static mgos_timer_id statusled_timer_id  = 0;
static uint8_t       statusled_gpio      = 0;
static bool          statusled_off_state = 0;

static void statusled_off_cb(void *arg) {
  mgos_gpio_write(statusled_gpio, statusled_off_state);
  statusled_timer_id = 0;
  (void)arg;
}

void statusled_blink() {
  if (statusled_gpio == GPIO_INVALID) {
    return;
  }

  mgos_gpio_write(statusled_gpio, !statusled_off_state);
  if (statusled_timer_id) {
    mgos_clear_timer(statusled_timer_id);
    statusled_timer_id = 0;
  }
  statusled_timer_id = mgos_set_timer(100, false, statusled_off_cb, NULL);
}

void statusled_init(uint8_t gpio, bool off_state) {
  statusled_gpio      = gpio;
  statusled_off_state = off_state;
  mgos_gpio_set_mode(statusled_gpio, MGOS_GPIO_MODE_OUTPUT);
  mgos_gpio_write(statusled_gpio, statusled_off_state);
}
